package entity

import "time"

type Product struct {
	ProductID           int64     `gorm:"primaryKey;autoIncrement" json:"product_id"` // 商品id
	ProductName         string    `gorm:"column:product_name"`                        // 商品名称
	ProductType         int64     `gorm:"column:product_type"`                        // 商品类型
	ProductCategory     string    `gorm:"column:product_category"`                    // 商品类目1--20
	ProductUrl          string    `gorm:"column:product_url"`                         // 商品链接，可为电商网址、公司官网、大众点评的店铺地址等可以说明商品信息或者品牌信息的线上地址；
	EnterpriseID        string    `gorm:"column:enterprise_id"`                       // 所属企业id
	SubAccountID        int64     `gorm:"column:sub_account_id"`                      // 子账号id
	ProductPrice        float64   `gorm:"column:product_price"`                       // 商品价值
	PublicCommission    float64   `gorm:"column:public_commission"`                   // 公开佣金
	ExclusiveCommission float64   `gorm:"column:exclusive_commission"`                // 专属佣金
	CommissionPrice     float64   `gorm:"column:commission_price"`                    // 佣金金额
	ProductDetail       string    `gorm:"column:product_detail"`                      // 卖点总结
	KuaishouProductId   string    `gorm:"column:kuaishou_product_id"`                 // 快手商品ID
	SalesCount          string    `gorm:"column:sales_count"`                         // 商品30天销量
	CreatedAt           time.Time `gorm:"column:created_at"`                          // 创建时间
	UpdatedAt           time.Time `gorm:"column:updated_at"`                          // 更新时间
}

func (m *Product) TableName() string {
	return "younggee_product"
}
