package vo

// 看数据-达人数据
type ReSelectionTalentData struct {
	AddWindowNum      []int64    `json:"addWindowNum"`      // 添加橱窗达人数
	AvgFanNum         int64      `json:"avgFanNum"`         // 平均粉丝数
	SalesDistribution []int64    `json:"salesDistribution"` // 领样达人销量分布[100-, 100-1000, 1000-5000, 5000-1w, 1w-10w, 10w+]
	FansDistribution  []int64    `json:"fansDistribution"`  // 达人粉丝数分布[1w-, 1w-10w, 10w-100w, 100w+]
	MaleNum           int64      `json:"maleNum"`
	FemaleNum         int64      `json:"femaleNum"`
	RegionRank        []RankItem `json:"regionRank"` // 达人地区分布（top10）
}

type RankItem struct {
	Region  string  `json:"region"`
	Percent float64 `json:"percent"`
}

// 看数据-领样数据
type ReSelectionSampleData struct {
	EnrollNum         []int64    `json:"enrollNum"`         // 报名人数
	AgreeSampleNum    int64      `json:"agreeSampleNum"`    // 同意寄样数
	SampledNum        int64      `json:"sampledNum"`        // 已发样数
	AvgFanNum         int64      `json:"avgFanNum"`         // 平均粉丝数
	SalesDistribution []int64    `json:"salesDistribution"` // 领样达人销量分布[100-, 100-1000, 1000-5000, 5000-1w, 1w-10w, 10w+]
	FansDistribution  []int64    `json:"fansDistribution"`  // 达人粉丝数分布[1w-, 1w-10w, 10w-100w, 100w+]
	MaleNum           int64      `json:"maleNum"`
	FemaleNum         int64      `json:"femaleNum"`
	RegionRank        []RankItem `json:"regionRank"` // 达人地区分布（top10）
}

// 看数据-带货数据
type ReSelectionData struct {
	PayData            []float64 `json:"payData"`           // 支付GMV
	EstimateData       []float64 `json:"estimateData"`      // 结算GMV
	ForecastCommission float64   `json:"forecastData"`      // 预估佣金支出
	PayOrderNum        []int64   `json:"payOrderNum"`       // 支付订单量
	SaleOrderNum       []int64   `json:"saleOrderNum"`      // 出单达人合计
	AvgCommissionRate  float64   `json:"avgCommissionRate"` // 平均佣金率
	TalentMsgList      ResultVO  `json:"talentMsgList"`     // 出单情况的达人信息
}

type TalentMsg struct {
	PhotoUrl string  `json:"photoUrl"`
	Nickname string  `json:"nickname"`
	Account  string  `json:"account"`
	OrderNum int64   `json:"orderNum"`
	GMV      float64 `json:"GMV"`
	Gender   int64   `json:"gender"`
}
