package vo

import (
	"youngee_m_api/app/entity"
)

type ReSelectionDetail struct {
	SelectionName string `json:"selection_name"` // 任务标题
	// 系统信息
	SelectionId       string  `json:"selectionId"`       // 项目id 生成规则:年(2位)+一年中的第几天(3位)+5位数随机数，雪花算法也可，生成10位订单号
	SelectionStatus   int64   `json:"selectionStatus"`   // 项目状态，1-8分别代表创建中、待审核、审核通过、待支付、已支付、执行中、失效、已结案
	SelectionPlatform int64   `json:"selectionPlatform"` //  项目平台，1-7分别代表红book、抖音、微博、快手、b站、大众点评、知乎
	CreatedAt         string  `json:"createdAt"`         // 创建时间
	SubmitAt          string  `json:"submitAt"`          // 提交审核时间
	PassAt            string  `json:"passAt"`            // 招募开始时间（审核通过时间）
	AutoFailAt        string  `json:"payEndAt"`          // 支付截止时间
	StartAt           string  `json:"startAt"`           // 执行开始时间（支付时间）
	FinishAt          string  `json:"finishAt"`          // 结案时间
	FailAt            string  `json:"failAt"`            // 失效时间
	CreatorName       string  `json:"creatorName"`       // 创建者
	Phone             string  `json:"phone"`             // 联系方式
	WX                string  `json:"wx"`                // 微信
	RewardSum         float64 `json:"rewardSum"`         // 悬赏池总金额
	// 支付方式参数待定
	// 关联商品
	ProductInfo *ReProductPreview `json:"productInfo"`
	// 样品奖励
	TaskDdl         string                   `json:"taskDdl"`
	SampleNum       int64                    `json:"sampleNum"` // 样品数量
	FreeStrategys   []*FreeStrategyPreview   // 领样策略
	RewardStrategys []*RewardStrategyPreview // 悬赏策略
	// 补充信息
	SelectionBriefs    []*entity.SecBrief    `json:"selectionBriefs"`    // 选品brief列表
	SelectionMaterials []*entity.SecMaterial `json:"selectionMaterials"` // 选品示例列表
}

type FreeStrategyPreview struct {
	StrategyId     int64 `json:"strategyId"`
	FollowersLow   int64 `json:"followers_low"` // 达人粉丝数下限
	FollowersUp    int64 `json:"followers_up"`  // 达人粉丝数上限
	SaleNum        int64 `json:"saleNum"`
	StrategyStatus int64 `json:"strategyStatus"` // 策略状态，1-2分别代表未删除、已删除
}

type RewardStrategyPreview struct {
	Reward         float64 `json:"reward"`
	SaleActual     int64   `json:"saleActual"`
	PerReward      float64 `json:"perReward"`
	StrategyStatus int64   `json:"strategyStatus"` // 策略状态，1-2分别代表未删除、已删除
}
