package db

import (
	"context"
	"youngee_m_api/model/gorm_model"
)

func FindUserInfoByTalentId(ctx context.Context, talentId string) (*gorm_model.PlatformKuaishouUserInfo, error) {
	db := GetReadDB(ctx)
	var userInfo gorm_model.PlatformKuaishouUserInfo
	err := db.Model(gorm_model.PlatformKuaishouUserInfo{}).Where("talent_id = ? and platform_id = ?", talentId, 4).Find(&userInfo).Error
	if err != nil {
		return nil, err
	}
	return &userInfo, nil
}

// FindUserInfoByOpenId 根据openID去查找快手授权信息
func FindUserInfoByOpenId(ctx context.Context, openId string) (*gorm_model.PlatformKuaishouUserInfo, error) {
	db := GetReadDB(ctx)
	var userInfo gorm_model.PlatformKuaishouUserInfo
	err := db.Model(gorm_model.PlatformKuaishouUserInfo{}).Where("open_id = ? and platform_id = ?", openId, 4).Find(&userInfo).Error
	if err != nil {
		return nil, err
	}
	return &userInfo, nil
}
