package db

import (
	"context"
	"fmt"
	"github.com/sirupsen/logrus"
	"youngee_m_api/model/gorm_model"
)

func CreateRewardStrategy(ctx context.Context, RewardStrategys []gorm_model.RewardStrategy) error {
	db := GetReadDB(ctx)
	fmt.Println("RewardStrategys: ", RewardStrategys)
	err := db.Create(&RewardStrategys).Error
	if err != nil {
		return err
	}
	return nil
}

func DeleteRewardStrategyBySelectionId(ctx context.Context, SelectionId string) error {
	db := GetReadDB(ctx)
	err := db.Where("selection_id = ?", SelectionId).Delete(&gorm_model.RewardStrategy{}).Error
	if err != nil {
		return err
	}
	return nil
}

func GetRewardStrategyBySelectionId(ctx context.Context, SelectionId string) ([]*gorm_model.RewardStrategy, error) {
	db := GetReadDB(ctx)
	var RewardStrategys []*gorm_model.RewardStrategy
	err := db.Model(gorm_model.RewardStrategy{}).Where("selection_id = ?", SelectionId).Find(&RewardStrategys).Error
	if err != nil {
		logrus.WithContext(ctx).Errorf("[GetRewardStrategyBySelectionId] error query, err:%+v", err)
		return nil, err
	}
	return RewardStrategys, nil
}
