package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_m_api/consts"
	"youngee_m_api/db"
	"youngee_m_api/model/http_model"
	"youngee_m_api/util"
)

func WrapDeleteProjectHandler(ctx *gin.Context) {
	handler := newDeleteProjectHandler(ctx)
	BaseRun(handler)
}

type DeleteProjectHandler struct {
	ctx  *gin.Context
	req  *http_model.DeleteProjectRequest
	resp *http_model.CommonResponse
}

func (c DeleteProjectHandler) getContext() *gin.Context { return c.ctx }
func (c DeleteProjectHandler) getResponse() interface{} { return c.resp }
func (c DeleteProjectHandler) getRequest() interface{} {
	return c.req
}
func (c DeleteProjectHandler) run() {
	data := http_model.DeleteProjectRequest{}
	data = *c.req
	err := db.DeleteProject(c.ctx, &data)
	if err != nil {
		logrus.Errorf("[DeleteProjectHandler] call DeleteProject err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorInternal, "")
		logrus.Info("DeleteProjectHandler fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功删除种草"
}
func (c DeleteProjectHandler) checkParam() error {
	return nil
}

func newDeleteProjectHandler(ctx *gin.Context) *DeleteProjectHandler {
	return &DeleteProjectHandler{
		ctx:  ctx,
		req:  http_model.NewDeleteProjectRequest(),
		resp: http_model.NewDeleteProjectResponse(),
	}
}
