package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_m_api/consts"
	"youngee_m_api/model/http_model"
	"youngee_m_api/service"
	"youngee_m_api/util"
)

func WrapGetTakegoodsDataHandler(ctx *gin.Context) {
	handler := newGetTakegoodsDataHandler(ctx)
	BaseRun(handler)
}

func newGetTakegoodsDataHandler(ctx *gin.Context) *GetTakegoodsDataHandler {
	return &GetTakegoodsDataHandler{
		req:  http_model.NewGetTakegoodsDataRequest(),
		resp: http_model.NewGetTakegoodsDataReponse(),
		ctx:  ctx,
	}
}

type GetTakegoodsDataHandler struct {
	req  *http_model.GetTakegoodsDataRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (h *GetTakegoodsDataHandler) getRequest() interface{} {
	return h.req
}
func (h *GetTakegoodsDataHandler) getContext() *gin.Context {
	return h.ctx
}
func (h *GetTakegoodsDataHandler) getResponse() interface{} {
	return h.resp
}
func (h *GetTakegoodsDataHandler) run() {
	data := http_model.GetTakegoodsDataRequest{}
	data = *h.req
	res, err := service.Workspace.GetTakegoodsInfo(h.ctx, data.EnterpriseId, data.DateRange)
	if err != nil {
		logrus.Errorf("[GetSelectionDetail] call Show err:%+v\n", err)
		util.HandlerPackErrorResp(h.resp, consts.ErrorInternal, "")
		logrus.Info("GetSelectionDetail fail,req:%+v", h.req)
		return
	}
	h.resp.Message = "成功查询带货量"
	h.resp.Data = res
}

func (h *GetTakegoodsDataHandler) checkParam() error {
	return nil
}
