package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	log "github.com/sirupsen/logrus"
	"youngee_m_api/consts"
	"youngee_m_api/db"
	"youngee_m_api/model/http_model"
	"youngee_m_api/util"
)

func WrapRefuseRechargeHandler(ctx *gin.Context) {
	handler := newRefuseRechargeHandler(ctx)
	BaseRun(handler)
}

func newRefuseRechargeHandler(ctx *gin.Context) *RefuseRechargeHandler {
	return &RefuseRechargeHandler{
		req:  http_model.NewRefuseRechargeRequest(),
		resp: http_model.NewRefuseRechargeResponse(),
		ctx:  ctx,
	}
}

type RefuseRechargeHandler struct {
	req  *http_model.RefuseRechargeRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (h *RefuseRechargeHandler) getRequest() interface{} {
	return h.req
}
func (h *RefuseRechargeHandler) getContext() *gin.Context {
	return h.ctx
}
func (h *RefuseRechargeHandler) getResponse() interface{} {
	return h.resp
}

func (h *RefuseRechargeHandler) run() {
	data := http_model.RefuseRechargeRequest{}
	data = *h.req
	res, err := db.RefuseRecharge(h.ctx, data)
	if err != nil {
		logrus.Errorf("[RefuseRechargeHandler] call RefuseRecharge err:%+v\n", err)
		util.HandlerPackErrorResp(h.resp, consts.ErrorInternal, "")
		log.Info("RefuseRecharge fail,req:%+v", h.req)
		return
	}
	h.resp.Message = "成功拒绝充值"
	h.resp.Data = res
	h.resp.Status = consts.ErrorSuccess
}

func (h *RefuseRechargeHandler) checkParam() error {
	return nil
}
