package handler

import (
	"youngee_m_api/consts"
	"youngee_m_api/model/http_model"
	"youngee_m_api/service"
	"youngee_m_api/util"

	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
)

func WrapReviewProjectHandler(ctx *gin.Context) {
	handler := newReviewProjectHandler(ctx)
	BaseRun(handler)
}

type ReviewProject struct {
	ctx  *gin.Context
	req  *http_model.ReviewProjectRequest
	resp *http_model.CommonResponse
}

func (c ReviewProject) getContext() *gin.Context {
	return c.ctx
}

func (c ReviewProject) getResponse() interface{} {
	return c.resp
}

func (c ReviewProject) getRequest() interface{} {
	return c.req
}

func (c ReviewProject) run() {
	data := http_model.ReviewProjectRequest{}
	data = *c.req
	res, err := service.Project.Review(c.ctx, data)
	if err != nil {
		logrus.Errorf("[ReviewProject] call ReviewProject err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorInternal, "")
		logrus.Info("ReviewProject fail,req:%+v", c.req)
		return
	}
	if data.IsPass == 1 {
		c.resp.Message = "审核成功"
	}
	c.resp.Data = res
}

func (c ReviewProject) checkParam() error {
	return nil
}

func newReviewProjectHandler(ctx *gin.Context) *ReviewProject {
	return &ReviewProject{
		ctx:  ctx,
		req:  http_model.NewReviewProjectRequest(),
		resp: http_model.NewReviewProjectResponse(),
	}
}
