package gorm_model

import (
	"time"
)

type YounggeeSupplierWithdraw struct {
	SupplierWithdrawId int       `gorm:"column:supplier_withdraw_id;type:int(11);primary_key;comment:提现流水ID" json:"supplier_withdraw_id"`
	SupplierId         int       `gorm:"column:supplier_id;type:int(11);comment:服务商ID" json:"supplier_id"`
	WithdrawAmount     float64   `gorm:"column:withdraw_amount;type:decimal(10,2);comment:提现金额" json:"withdraw_amount"`
	AmountPayable      float64   `gorm:"column:amount_payable;type:decimal(10,2);comment:实际提现金额（扣税后）" json:"amount_payable"`
	InvoiceIds         string    `gorm:"column:invoice_ids;type:varchar(255);comment:发票ID列表（根据发票ID去查对应的income)" json:"invoice_ids"`
	IncomeIds          string    `gorm:"column:income_ids;type:varchar(255);comment:收入列表（个人服务商不需要回票所以看这个）" json:"income_ids"`
	Company            string    `gorm:"column:company;type:varchar(255);comment:机构名称" json:"company"`
	SupplierType       int       `gorm:"column:supplier_type;type:int(11);comment:服务商用户类型，1为个人PR，2为机构" json:"supplier_type"`
	Name               string    `gorm:"column:name;type:varchar(255);comment:姓名" json:"name"`
	IdNumber           string    `gorm:"column:id_number;type:varchar(255);comment:身份证号码" json:"id_number"`
	BankName           string    `gorm:"column:bank_name;type:varchar(255);comment:提现银行" json:"bank_name"`
	BankNumber         int       `gorm:"column:bank_number;type:int(11);comment:提现银行卡号" json:"bank_number"`
	Phone              string    `gorm:"column:phone;type:varchar(255);comment:手机号码" json:"phone"`
	WithdrawStatus     int       `gorm:"column:withdraw_status;type:int(11);comment:提现状态：1待提现，2提现中，3已提现，4已驳回" json:"withdraw_status"`
	SupplyTime         time.Time `gorm:"column:supply_time;type:datetime" json:"supply_time"`
	AgreeTime          time.Time `gorm:"column:agree_time;type:datetime" json:"agree_time"`
	RejectTime         time.Time `gorm:"column:reject_time;type:datetime" json:"reject_time"`
	FailReson          string    `gorm:"column:fail_reson;type:varchar(255)" json:"fail_reson"`
}

func (m *YounggeeSupplierWithdraw) TableName() string {
	return "younggee_supplier_withdraw"
}
