package http_model

import "youngee_m_api/model/gorm_model"

type SubAccountDetailRequest struct {
	PageSize      int    `json:"page_size"`
	PageNum       int    `json:"page"`
	JobId         *int   `json:"job_id,omitempty"`         // 可选的岗位类型
	AccountStatus *int   `json:"account_status,omitempty"` // 可选的账号状态
	Others        string `json:"others,omitempty"`         //手机号或账号名称
}

type SubAccountDetailResponse struct {
	SubAccountInfo gorm_model.YounggeeSubAccount //子账号详情
	JobName        string                        `json:"job_name"`
	Creater        string                        `json:"creater"`
}

type SubAccountData struct {
	SubAccountInfo []*SubAccountDetailResponse `json:"SubAccountData"`
	Total          string                      `json:"total"`
}

func NewSubAccountDetailRequest() *SubAccountDetailRequest {
	return new(SubAccountDetailRequest)
}

func NewSubAccountDetailResponse() *CommonResponse {
	resp := new(CommonResponse)
	resp.Data = new(SubAccountData)
	return resp
}
