package http_model

type UpdateSelectionRequest struct {
	EnterpriseId     string                  `json:"enterprise_id"`
	SelectionID      string                  `json:"selection_id"` // 选品id
	SelectionStatus  int                     `json:"selection_status"`
	Platform         int                     `json:"platform"`
	ProductId        string                  `json:"product_id"`
	ContentType      int                     `json:"content_type"`
	TaskMode         int                     `json:"task_mode"`
	SampleNum        int                     `json:"sample_num"`  // 样品数量
	RemainNum        int                     `json:"remain_num"`  // 剩余数量
	TaskReward       float64                 `json:"task_reward"` // 任务悬赏
	TaskDdl          string                  `json:"task_ddl"`
	SampleMode       int                     `json:"sample_mode"`
	CommissionRate   string                  `json:"commission_rate"`
	ProductUrl       string                  `json:"product_url"`
	SampleCondition  string                  `json:"sample_condition"`
	RewardCondition  string                  `json:"reward_condition"` // 返现悬赏条件
	SecBrief         []*SecBriefInfo         `json:"sec_brief"`
	SecExample       []*SecExampleInfo       `json:"sec_example"`
	Detail           string                  `json:"detail"`
	SettlementAmount float64                 `json:"settlement_amount"`
	FreeStrategys    []UpdateFreeStrategys   `json:"free_strategys"`   // 免费领样策略
	RewardStrategys  []UpdateRewardStrategys `json:"reward_strategys"` // 悬赏策略
	Status           int                     `json:"status"`           // 是否删除
}

type SecBriefInfo struct {
	PhotoUrl string `json:"photo_url"`
	PhotoUid string `json:"photo_uid"`
	Name     string `json:"name"`
}

type SecExampleInfo struct {
	PhotoUrl string `json:"photo_url"`
	PhotoUid string `json:"photo_uid"`
	Name     string `json:"name"`
}

type UpdateSelectionData struct {
	SelectionId string `json:"selection_id"`
}

type UpdateProductData struct {
	ProductId string `json:"product_id"`
}

type UpdateFreeStrategys struct {
	StrategyId int64 `json:"strategy_id"` // 策略编号
	FansNum    int64 `json:"fans_num"`    // 粉丝数目
	SaleNum    int64 `json:"sale_num"`    // 近30天橱窗销量
	EnrollNum  int64 `json:"enroll_num"`  // 报名人数
	ChooseNum  int64 `json:"choose_num"`  // 已选人数
}

type UpdateRewardStrategys struct {
	Reward     float64 `json:"reward"`      // 悬赏池总金额
	SaleActual int64   `json:"sale_actual"` // 实际带货销量
	PerReward  float64 `json:"per_reward"`  // 每人可获得悬赏金
}

func NewUpdateSelectionRequest() *UpdateSelectionRequest {
	return new(UpdateSelectionRequest)
}

func NewUpdateSelectionResponse() *CommonResponse {
	resp := new(CommonResponse)
	resp.Data = new(UpdateSelectionData)
	return resp
}
