package http_model

import "time"

type GetInvoiceListRequest struct {
	PageSize int `json:"page_size"`
	PageNum  int `json:"page"`
	Status   int `json:"status"`
}

type InvoiceListResponse struct {
	BillingID     string    `json:"billing_id"`
	InvoiceAmount float64   `json:"invoice_amount"`
	Operator      string    `json:"operator"`
	SubmitAt      time.Time `json:"submit_at"`
	AgreeAt       time.Time `json:"agree_at"`
	TaskNumber    int       `json:"task_number"`
	InvoiceType   int64     `json:"invoice_type"`
}

type InvoiceListData struct {
	InvoiceListinfo []*InvoiceListResponse `json:"invoice_list_info"`
	Total           int64                  `json:"total"`
}

func NewGetInvoiceListRequest() *GetInvoiceListRequest {
	return new(GetInvoiceListRequest)
}

func NewGetInvoiceListResponse() *CommonResponse {
	resp := new(CommonResponse)
	resp.Data = new(InvoiceListData)
	return resp
}
