package http_model

type GetLocalTaskListRequest struct {
	PageSize       int      `json:"page_size"`
	PageNum        int      `json:"page"`
	TalentFromList string   `json:"talent_from_list"`
	FeeFrom        *int     `json:"fee_from,omitempty"`
	Type           *int     `json:"type,omitempty"` // 查询类型，1、2分别表示达人来源于公海(商家端)，服务商
	ProjectId      string   `json:"project_id"`
	CoopType       int      `json:"coop_type"` //1未处理,2同意，3拒绝
	EnterPriseId   string   `json:"enterprise_id"`
	SortField      []string `json:"sort_field,omitempty"`
	SortOrder      []string `json:"sort_order,omitempty"`
	Others         string   `json:"others,omitempty"`
}

type GetLocalTaskListData struct {
	TaskList []*LocaLTaskInfo `json:"task_list"`
	Total    string           `json:"total"`
}

type LocaLTaskInfo struct {
	TaskId             string  `json:"task_id"`
	ProjectId          string  `json:"project_id"`
	TalentId           string  `json:"talent_id"`
	FansNum            int     `json:"fans_num"`
	DraftFee           float64 `json:"draft_fee"`
	FeeFrom            int     `json:"fee_from"`
	TaskStage          int     `json:"task_stage"`
	Voteavg            int     `json:"vote_avg"`
	Commentavg         int     `json:"commit_avg"`
	CollectNum         int     `json:"collect_num"`
	CurrentDefaultType int     `json:"current_default_type"`
	From               int     `json:"from"`   //1公海，2服务商
	SType              int     `json:"s_type"` //1个人，2机构
	SName              string  `json:"sname"`
	Boperator          string  `json:"b_operator"`
	//SettleAmount       float64   `json:"settle_amount"`
	CreateAt   string `json:"create_time"`
	ISCoop     int    `json:"is_coop"`
	Gender     string `json:"gender"`
	NickName   string `json:"nick_name"`
	HeadUrl    string `json:"head_url"`
	Sprojectid int    `json:"sprojectid"`
	City       string `json:"city"`
	ListTime   string `json:"list_time"`
	StageIntro string `json:"stage_intro"`
}

func NewGetLocalTaskListRequest() *GetLocalTaskListRequest {
	return new(GetLocalTaskListRequest)
}

func NewGetLocalTaskListResponse() *CommonResponse {
	resp := new(CommonResponse)
	resp.Data = new(GetLocalTaskListData)
	return resp
}
