package http_model

import "time"

type GetSupplierInvoiceListRequest struct {
	PageSize int `json:"page_size"`
	PageNum  int `json:"page"`
	Status   int `json:"status"`
}

type SupplierInvoiceListResponse struct {
	InvoiceId     int         `json:"invoice_id"`
	InvoiceAmount float64     `json:"invoice_amount"`
	PhoneNumber   string      `json:"phone_number"`
	SupplierName  string      `json:"supplier_name"`
	Taskinfo      *[]Tasklist `json:"taskinfo"`
	Name          string      `json:"name"`
	CompanyName   string      `json:"company_name"`
	SubmitAt      time.Time   `json:"submit_at"`
	AggreeAt      time.Time   `json:"aggree_at"`
	SupplierId    int         `json:"supplier_id"`
	ReajectAt     time.Time   `json:"reject_at"`
	ReajectReason string      `json:"reject_reason"`
	Avater        string      `json:"avater"`
	InvoiceUrl    string      `json:"invoice_url"`
}

type Tasklist struct {
	Id  int     `json:"id"`
	Fee float64 `json:"fee"`
}
type SupplierInvoiceListData struct {
	InvoiceListinfo []*SupplierInvoiceListResponse `json:"invoice_list_info"`
	Total           int64                          `json:"total"`
}

func NewGetSupplierInvoiceListRequest() *GetSupplierInvoiceListRequest {
	return new(GetSupplierInvoiceListRequest)
}

func NewGetSupplierInvoiceListResponse() *CommonResponse {
	resp := new(CommonResponse)
	resp.Data = new(SupplierInvoiceListData)
	return resp
}
