package http_model

type TaskDatalistRequest struct {
	PageSize     int      `json:"page_size"`
	PageNum      int      `json:"page"`
	ProjectId    string   `json:"project_id"`  // 项目ID
	DataStatus   string   `json:"data_status"` // 链接状态，14
	EnterpriseId string   `json:"enterprise_id"`
	SortField    []string `json:"sort_field,omitempty"`
	SortOrder    []string `json:"sort_order,omitempty"`
	Others       string   `json:"others,omitempty"`
}

type GetTaskDatalistData struct {
	TaskDatalist []*TaskDatainfo `json:"task_list"`
	Total        string          `json:"total"`
}

type TaskDatainfo struct {
	Task          *TaskInfo `json:"task_info"`
	SubmitAt      string    `json:"submit_at"` // 提交时间
	AgreeAt       string    `json:"agree_at"`
	DataId        int       `json:"data_id"` //初稿ID
	PhotoUrl      string    `json:"photo_url"`
	PlayNumber    int       `json:"play_number"`
	LikeNumber    int       `json:"like_number"`
	CommentNumber int       `json:"comment_number"`
	CollectNumber int       `json:"collect_number"`
	SettleAmount  float64   `json:"settle_amount"`
	Breakrate     int       `json:"breakrate"`
	Operator      string    `json:"operator"`
}

func NewTaskDatalistRequest() *TaskDatalistRequest {
	return new(TaskDatalistRequest)
}

func NewTaskDatalistResponse() *CommonResponse {
	resp := new(CommonResponse)
	resp.Data = new(GetTaskDatalistData)
	return resp
}
